//notation: js file can only use this kind of comments
//since comments will cause error when use in webview.loadurl,
//comments will be remove by java use regexp
(function () {
//    console.log('注入！！！@');
    if (window.WebViewJavascriptBridge) {
        return;
    }

    var messagingIframe;
    var bizMessagingIframe;
    var sendMessageQueue = [];
    // var receiveMessageQueue = [];
    var messageHandlers = {};

    var CUSTOM_PROTOCOL_SCHEME = 'yy';
    var QUEUE_HAS_MESSAGE = '__QUEUE_MESSAGE__/';

    var responseCallbacks = {};
    var uniqueId = 1;
    var successFunction = {};
    var failFunction = {};

    function callHandler(className, action, messageData, success, fail) {
        var message = {};
        if (messageData && messageData instanceof Array) {
            for (let i = 0; i < messageData.length; i++) {
                let value = messageData[i];
                let key = 'msg' + i;
                let jsonData = {};
                if (typeof value === "string") {
                    jsonData[key] = value;
//                    console.log('in0 ' + i + " string");
                    messageData[i] = jsonData;
                } else if (typeof value === "number") {
                    jsonData[key] = String(value);
//                    console.log('in0 ' + i + " number");
                    messageData[i] = jsonData;
                }
            }
            message.args = messageData;
        }
        message.action = action;
        var sendData = {
            // handlerName: className + "#" + action,
            handlerName: className,
            data: message,
            action: action
        }
        if (success && fail) {
            //此处需确认是否不可为null
            var callbackId = 'cb_' + (uniqueId++) + '_' + new Date().getTime();
            successFunction[callbackId] = success;
            failFunction[callbackId] = fail
            sendData.callbackId = callbackId;
        }

        sendMessageQueue.push(sendData);
        var messageQueueString = JSON.stringify(sendMessageQueue);
//        console.log('in1 ' + messageQueueString);
        messagingIframe.src = CUSTOM_PROTOCOL_SCHEME + '://' + QUEUE_HAS_MESSAGE;
//        console.log('in2 ' + CUSTOM_PROTOCOL_SCHEME + '://' + QUEUE_HAS_MESSAGE);
    }


    // 创建消息index队列iframe
    function _createQueueReadyIframe(doc) {
        messagingIframe = doc.createElement('iframe');
        messagingIframe.style.display = 'none';
        doc.documentElement.appendChild(messagingIframe);
    }

    //创建消息体队列iframe
    function _createQueueReadyIframe4biz(doc) {
        bizMessagingIframe = doc.createElement('iframe');
        bizMessagingIframe.style.display = 'none';
        doc.documentElement.appendChild(bizMessagingIframe);
    }

    // 提供给native调用,该函数作用:获取sendMessageQueue返回给native,由于android不能直接获取返回的内容,所以使用url shouldOverrideUrlLoading 的方式返回内容
    function _fetchQueue(sdkVersion) {
        var messageQueueString = JSON.stringify(sendMessageQueue);
//        console.log('in3 ' + sdkVersion);
        sendMessageQueue = [];
        //android can't read directly the return data, so we can reload iframe src to communicate with java
        if (messageQueueString !== '[]') {
            if (sdkVersion > 18) {
//                console.log('in3 >18');
                // let data = {};
                // let key = 'returnData';
                let url = CUSTOM_PROTOCOL_SCHEME + '://return/_fetchQueue/' + encodeURIComponent(messageQueueString);
                // data[key] = url;
                return url;
            } else {
//                console.log('in3 <=18');
                bizMessagingIframe.src = CUSTOM_PROTOCOL_SCHEME + '://return/_fetchQueue/' + encodeURIComponent(messageQueueString);
            }
        }
    }

    //提供给native使用,
    function _dispatchMessageFromNative(messageJSON) {
        setTimeout(function () {
            var message = JSON.parse(messageJSON);
            var success;
            var fail;
            var respData;
            //java call finished, now need to call js callback function
            if (message.responseId) {
                success = successFunction[message.responseId];
                fail = failFunction[message.responseId];
                respData = JSON.parse(message.responseData);
                if (!success) {
                    console.log('in5 error success null');
                    delete failFunction[message.responseId];
                    return;
                }
                if (!fail) {
                    console.log('in5 error fail null');
                    delete success[message.responseId];
                    return;
                }
                if (!respData) {
                    console.log('in5 error resp null');
                    delete failFunction[message.responseId];
                    delete successFunction[message.responseId];
                    return;
                }
                console.log('in5 code' + respData.resultCode);
                if ("00" == respData.resultCode) {
                    console.log('in5 success');
                    success(respData)
                } else {
                    console.log('in5 failed');
                    fail(respData)
                }
                // responseCallback(message.responseData);
                // delete responseCallbacks[message.responseId];
                delete failFunction[message.responseId];
                delete successFunction[message.responseId];
                return;
            }
            // native调用js，云闪付不使用此套逻辑
            // else {
            //     //直接发送
            //     if (message.callbackId) {
            //         var callbackResponseId = message.callbackId;
            //         responseCallback = function (responseData) {
            //             _doSend({
            //                 responseId: callbackResponseId,
            //                 responseData: responseData
            //             });
            //         };
            //     }
            //
            //     var handler = WebViewJavascriptBridge._messageHandler;
            //     if (message.handlerName) {
            //         handler = messageHandlers[message.handlerName];
            //     }
            //     //查找指定handler
            //     try {
            //         handler(message.data, responseCallback);
            //     } catch (exception) {
            //         if (typeof console != 'undefined') {
            //             console.log("WebViewJavascriptBridge: WARNING: javascript handler threw.", message, exception);
            //         }
            //     }
            // }
        });
    }

    //提供给native调用,receiveMessageQueue 在会在页面加载完后赋值为null,所以
    function _handleMessageFromNative(messageJSON) {
//        console.log('in4 ' + messageJSON);
        // if (receiveMessageQueue) {
        //     receiveMessageQueue.push(messageJSON);
        // }
        _dispatchMessageFromNative(messageJSON);

    }

    function _dispatchEventFromNative(eveName) {
        if (eveName) {
            eventFromNative.initEvent(eveName);
            doc.dispatchEvent(eventFromNative);
//            console.log(eveName + " dispatch");
        }


    }

    var WebViewJavascriptBridge = window.WebViewJavascriptBridge = {
            _fetchQueue: _fetchQueue,
            _handleMessageFromNative: _handleMessageFromNative,
            _dispatchEventFromNative: _dispatchEventFromNative,
            callHandler: callHandler
        }
    ;

    var doc = document;
    _createQueueReadyIframe(doc);
    _createQueueReadyIframe4biz(doc);
    var eventFromNative = doc.createEvent('Events');
})();
